from graph import Graph
from vertex import Vertex
from linked_queue import LinkedQueue
from binheap import BinHeap
from binheap import PriorityQueueEntry
import sys


def dijkstra(aGraph,start):  
  pq = PriorityQueue()
  start.setDistance(0)
  pq.buildHeap([(v.getDistance(),v) for v in aGraph])        
  while not pq.isEmpty():
    currentVert = pq.delMin()
    for nextVert in currentVert.getConnections():
      newDist = currentVert.getDistance() \
                + currentVert.getWeight(nextVert)
      if newDist < nextVert.getDistance():
        nextVert.setDistance( newDist )
        nextVert.setPred(currentVert)
        pq.decreaseKey(nextVert,newDist)  

def prim(G,start):
    pq = BinHeap()
    for v in G:
        v.setDistance(sys.maxsize)
        v.setPred(None)
    start.setDistance(0)
    pq.buildHeap([PriorityQueueEntry(v.getDistance(),v) for v in G])
    while not pq.isEmpty():
        currentVert = pq.delMin().getValue()
        if currentVert.getPred() != None:
          print("Prim: edge",currentVert.getPred().getId(), "to", currentVert.getId())
        for nextVert in currentVert.getConnections():
          newCost = currentVert.getWeight(nextVert)
          if PriorityQueueEntry(0,nextVert) in pq and newCost<nextVert.getDistance():
              nextVert.setPred(currentVert)
              nextVert.setDistance(newCost)
              pq.decreaseKey(PriorityQueueEntry(newCost, nextVert))

